# Probuster
Probuster : A Python based Web Application Penetration testing tool for Information Gathering⚡.

Probuster is a cutting-edge reconnaissance toolkit meticulously crafted for ethical hackers, penetration testers, bug bounty hunters and security professionals seeking unparalleled precision in the art of information gathering. This versatile tool seamlessly integrates four distinctive modes, empowering users with unprecedented insights into network landscapes.

**DNS Mode: Unleash the Power of Threaded DNS Enumeration**

In DNS mode, Probuster employs state-of-the-art threaded techniques to perform rapid and comprehensive DNS enumeration. Uncover hidden subdomains, identify potential vulnerabilities, and map the intricate web of domain structures with unparalleled efficiency. Probuster's DNS mode is designed for speed, accuracy, and reliability, ensuring a thorough examination of your target's digital footprint.

**Dir Mode: Elevate Directory and File Enumeration to New Heights**

Probuster's Dir mode elevates directory and file enumeration to new heights. Effortlessly scan web applications for hidden gems, vulnerable endpoints, and critical files. With Probuster's intelligent algorithms and intuitive interface, identify potential security loopholes and streamline your penetration testing workflow with unparalleled ease.

**VHost Mode: Illuminate Virtual Host Structures with Precision**

Illuminate the virtual host landscape using Probuster's VHost mode. Uncover obscured hosts, validate configurations, and gain a granular understanding of the web infrastructure. Probuster's VHost mode delivers accurate virtual host enumeration, enabling security professionals to assess attack surfaces comprehensively and make informed decisions.

**Docs Mode: Explore Comprehensive Documentation with Ease**

Probuster's Docs mode provides a seamlessly integrated documentation hub. Explore comprehensive guides, usage examples, and detailed explanations of each mode. Whether you're a seasoned professional or a beginner, Probuster's documentation ensures that you can harness the full power of the toolkit with confidence.

**Key Features:**

- **Threaded Efficiency:** Probuster harnesses the power of multithreading for rapid and parallelized reconnaissance, ensuring swift and effective scans.
  
- **User-Friendly Interface:** A sleek and intuitive interface facilitates seamless navigation, making Probuster a tool of choice for both novice and seasoned cybersecurity professionals.

- **Customizable Settings:** Tailor Probuster to your specific needs with customizable settings, allowing fine-tuning for different environments and scenarios.

- **Comprehensive Reporting:** Generate detailed reports that encapsulate findings, aiding in concise communication of discovered vulnerabilities and potential risks.
- **Tool management**: Probuster can be easily installed and easily manage your command line tool because Probuster ⚡ is also a python package
- **Platform Independent:**: Probuster can be easily installed and can be easily build on any operating system and can be used for your Recon process even on your Android and Ios devices

Probuster is not just a tool, it's a manifestation of excellence in reconnaissance, designed to empower ethical hackers with the precision needed to navigate the complexities of modern cybersecurity landscapes. Elevate your penetration testing 
capabilities with Probuster and redefine your approach to ethical hacking. 

### Installation:

Probuster can be easily installed as you desired either through `pip` or `git clone` it depends on your choice

#### Installation through pip:

```bash
pip install probuster

probuster -h
```
If you system has encountered in system depended error use this command to install
```bash
pip install probuster --break-system-packages
```
If your system has encountered any permission errors then try this command

```bash
sudo pip install probuster
```
#### Installation through git clones:

```bash
git clone https://github.com/sanjai-AK47/Probuster.git
cd Probuster
sudo pip install . or pip install .
probuster -h
```

Hey Wait a Minute! how to use Probuster? 😆, see the documentation of Probuster by this command

```bash
probuster doc
```
Then you will see the probuster documentation and its usages

## Probuster GitHub Repository

Head over to the [Probuster GitHub repository](https://github.com/sanjai-AK47/Probuster). Dive into the code, contribute your expertise, and share your experiences and feedback. This tool is a collaborative effort, 
## About the Author

I'm D. Sanjai Kumar, the creator of Probuster. I'm passionate about advancing cybersecurity, and Probuster is a testament to that passion. Connect with me on [LinkedIn](https://www.linkedin.com/in/d-sanjai-kumar-109a7227b).

## Show Your Support

If Probuster has rocked your ethical hacking world, let's spread the love! Give the repository a star :star: on [GitHub](https://github.com/sanjai-AK47/Probuster). Share it with your network, and let's build a community around this tool.

Got feedback, suggestions, or want to contribute? Reach out to me directly. Let's keep pushing the boundaries of cybersecurity and innovation together.

Thank you for choosing Probuster. Now, go out there and hack responsibly!

---

### Disclaimer:
Probuster is designed for ethical hacking and penetration testing. Any use for malicious activities is strictly prohibited.

Moye Moye ! 

---
